



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>RichEditBox 使用自定义菜单</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">RichEditBox 使用自定义菜单</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 06:03:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>老周：当RichEditBox控件的上下文菜单即将弹出时，会引发ContextMenuOpening事件，我们需要处理该事件，并且将e.Handled属性设置为true，这样才能阻止默认上下文菜单的弹出</p>
<p>在RichEditBox控件上声明附加的菜单项</p>
<pre class="prettyprint linenums"><code>&lt;RichEditBox Name="redit" Grid.Row="3" Margin="10,10,10,10" ContextMenuOpening="OnContextMenuOpening"&gt;
            &lt;FlyoutBase.AttachedFlyout&gt;
                &lt;MenuFlyout&gt;
                    &lt;MenuFlyoutItem Text="复制" Click="OnCopy"/&gt;
                    &lt;MenuFlyoutItem Text="剪切" Click="OnCut"/&gt;
                    &lt;MenuFlyoutItem Text="粘贴" Click="OnPaste"/&gt;
                    &lt;MenuFlyoutSeparator/&gt;
                    &lt;MenuFlyoutSubItem Text="字号"&gt;
                        &lt;MenuFlyoutItem Text="16" Tag="16" Click="OnFontSize" /&gt;
                        &lt;MenuFlyoutItem Text="20" Tag="20" Click="OnFontSize"/&gt;
                        &lt;MenuFlyoutItem Text="24" Tag="24" Click="OnFontSize" /&gt;
                        &lt;MenuFlyoutItem Text="36" Tag="36" Click="OnFontSize"/&gt;
                        &lt;MenuFlyoutItem Text="48" Tag="48" Click="OnFontSize"/&gt;
                    &lt;/MenuFlyoutSubItem&gt;
                    &lt;!--分割--&gt;
                    &lt;MenuFlyoutSeparator/&gt;
                    &lt;ToggleMenuFlyoutItem Text="加粗" Click="OnBold" /&gt;
                    &lt;MenuFlyoutSeparator/&gt;
                    &lt;MenuFlyoutSubItem Text="下划线"&gt;
                        &lt;MenuFlyoutItem Text="无" Tag="-1" Click="OnUnderline" /&gt;
                        &lt;MenuFlyoutItem Text="单实线" Tag="0" Click="OnUnderline"/&gt;
                        &lt;MenuFlyoutItem Text="双实线" Tag="1" Click="OnUnderline"/&gt;
                        &lt;MenuFlyoutItem Text="虚线" Tag="2" Click="OnUnderline"/&gt;
                    &lt;/MenuFlyoutSubItem&gt;
                    &lt;MenuFlyoutSeparator/&gt;
                    &lt;MenuFlyoutSubItem Text="颜色"&gt;
                        &lt;MenuFlyoutItem Text="黑色" Tag="黑色" Click="OnTinct"/&gt;
                        &lt;MenuFlyoutItem Text="蓝色" Tag="蓝色" Click="OnTinct"/&gt;
                        &lt;MenuFlyoutItem Text="白色" Tag="白色" Click="OnTinct"/&gt;
                    &lt;/MenuFlyoutSubItem&gt;
                &lt;/MenuFlyout&gt;
            &lt;/FlyoutBase.AttachedFlyout&gt;
        &lt;/RichEditBox&gt;</code></pre>
<p>处理OnContextMenuOpening</p>
<pre class="prettyprint linenums"><code>        private void OnContextMenuOpening(object sender , ContextMenuEventArgs e)
        {
            //阻止弹出默认的上下文菜单，然后，调用ShowAt方法在指定的坐标处打开菜单
            e.Handled = true;
            MenuFlyout menu = FlyoutBase.GetAttachedFlyout(redit) as MenuFlyout;
            menu?.ShowAt(redit , new Point(e.CursorLeft , e.CursorTop));
        }</code></pre>
<p>处理复制粘贴</p>
<pre class="prettyprint linenums"><code>private void OnCopy(object sender , RoutedEventArgs e)
        {
            //复制
            redit.Document.Selection.Copy();
        }

        private void OnCut(object sender , RoutedEventArgs e)
        {
            //剪切
            redit.Document.Selection.Cut();
        }

        private void OnPaste(object sender , RoutedEventArgs e)
        {
            //粘贴
            redit.Document.Selection.Paste(0);
            //Paste 要在粘贴操作中使用的剪贴板格式。零表示最佳格式
        }</code></pre>
<p>处理OnFontSize</p>
<pre class="prettyprint linenums"><code>        /// &lt;summary&gt;
        /// 设置字体
        /// &lt;/summary&gt;
        /// &lt;param name="sender"&gt;&lt;/param&gt;
        /// &lt;param name="e"&gt;&lt;/param&gt;
        private void OnFontSize(object sender , RoutedEventArgs e)
        {
            MenuFlyoutItem item = sender as MenuFlyoutItem;
            // 获取字号
            float size = Convert.ToSingle(item.Tag);

            redit.Document.Selection.CharacterFormat.Size = size;
        }</code></pre>
<pre class="prettyprint linenums"><code> /// &lt;summary&gt;
        /// 加粗
        /// &lt;/summary&gt;
        /// &lt;param name="sender"&gt;&lt;/param&gt;
        /// &lt;param name="e"&gt;&lt;/param&gt;
        private void OnBold(object sender , RoutedEventArgs e)
        {
            //using Windows.UI.Text;
            ToggleMenuFlyoutItem item = sender as ToggleMenuFlyoutItem;
            redit.Document.Selection.CharacterFormat.Bold = item.IsChecked ? FormatEffect.On : FormatEffect.Off;
        }

        private void OnUnderline(object sender , RoutedEventArgs e)
        {
            MenuFlyoutItem item = sender as MenuFlyoutItem;
            int x = Convert.ToInt32(item.Tag);
            UnderlineType unlinetp;
            switch (x)
            {
                case -1: // 无
                    unlinetp = UnderlineType.None;
                    break;
                case 0: // 单实线
                    unlinetp = UnderlineType.Single;
                    break;
                case 1: // 双实线
                    unlinetp = UnderlineType.Double;
                    break;
                case 2: // 虚线
                    unlinetp = UnderlineType.Dash;
                    break;
                default:
                    unlinetp = UnderlineType.None;
                    break;
            }
            redit.Document.Selection.CharacterFormat.Underline = unlinetp;
        }</code></pre>
<pre class="prettyprint linenums"><code>        private void OnTinct(object sender , RoutedEventArgs e)
        {
            MenuFlyoutItem item = sender as MenuFlyoutItem;
            string tinct = item.Tag as string;
            Windows.UI.Color color = new Windows.UI.Color();
            switch (tinct)
            {
                case "黑色":
                    color= Windows.UI.Colors.Black;
                    break;
                case "蓝色":
                    color = Windows.UI.Colors.Blue;
                    break;
                case "白色":
                    color = Windows.UI.Colors.White;
                    break;
                default:
                    break;
            }
            redit.Document.Selection.CharacterFormat.BackgroundColor = color;
        }
</code></pre>
<p>颜色在Windows.UI.Color</p>
<p>里面代码都是抄老周的</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20151210162138179"></p>
<p>参考：<a href="http://www.cnblogs.com/tcjiaan/p/4937301.html" rel="external nofollow noreferrer">http://www.cnblogs.com/tcjiaan/p/4937301.html</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1jz4qg.html">C语言可以开发哪些项目？</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxkn508.html">如何在centos下部署Node环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvz3jz9.html">解决：IntelliJ IDEA 编译错误，提示  Compilation failed&colon; internal java compiler error</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyr7l28.html">Hollister Outlet Store</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rme078.html">HTTP2&period;0介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvp46yq.html">&lbrack;深入浅出Windows 10&rsqb;应用实战：Bing在线壁纸</a>
		</li>
						<li><a href="https://www.batexi.com/a/3905jonq.html">Java Collection框架详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0xeeq.html">《android 导入第三方源码jar包遇到的坑》</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7ypeeq.html">Hive操作表部分总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mndz12q.html">使用RedisTemplate的操作类访问Redis&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd65d2q.html">Android M Permission处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x1oxz8.html">PV、UV、IP的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2gkx9.html">-bash&colon; mysql&colon; command not found 解决办法 &lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z74ve9.html">开心的金明&amp;lt&semi;0-1背包&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1lwodq.html">c语言环境初始化&amp;amp&semi;c语言和汇编混合编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p6px38.html">69&period; x 的平方根</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2eo4z9.html">C&num;事件の事件聚合器（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gnwrvq.html">spring事务传播行为之使用REQUIRES&lowbar;NEW不回滚</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj4vw39.html">Centos下Nodejs&plus;npm环境-部署记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw46jx9.html">wamp phpcms部署网站问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zo667dq.html">团队作业4&mdash;&mdash;第一次项目冲刺（Alpha版本）第五天</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1jjyoq.html">【Alpha】&mdash;&mdash;Sixth Scrum Meeting</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpgxpvq.html">201521123054《JAVA程序设计》第三周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk64ej8.html">201521123110第二周Java学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jg64v8.html">201521123005 《Java程序设计》 第十四周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljw2rx9.html">dup和dup2详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj3rd5q.html">Bootstrap Table急速完美搭建后台管理系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo6nddq.html">HDU2688-Rotate</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z2r7x9.html">javaWeb正则表达式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mey0o2q.html">Vue&period;js的从入门到放弃进击录（二）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
